From ce3632fc60dacecaa63072751bb9b6783fce7799 Mon Sep 17 00:00:00 2001
From: Konstantin Kuzov <master.nosferatu@gmail.com>
Date: Fri, 31 Aug 2018 10:38:25 +0300
Subject: [PATCH] xl2tpd: proto support for new add dependency functionality

Signed-off-by: Konstantin Kuzov <master.nosferatu@gmail.com>
---
 net/xl2tpd/files/l2tp.sh | 14 ++++++++++----
 1 file changed, 10 insertions(+), 4 deletions(-)
 mode change 100644 => 100755 net/xl2tpd/files/l2tp.sh

diff --git a/net/xl2tpd/files/l2tp.sh b/net/xl2tpd/files/l2tp.sh
old mode 100644
new mode 100755
index c565d6b..30d836e
--- a/net/xl2tpd/files/l2tp.sh
+++ b/net/xl2tpd/files/l2tp.sh
@@ -17,6 +17,8 @@ proto_l2tp_init_config() {
 	proto_config_add_int "mtu"
 	proto_config_add_int "checkup_interval"
 	proto_config_add_string "server"
+	proto_config_add_boolean "route_disable"
+	proto_config_add_string "route_interface"
 	available=1
 	no_device=1
 	no_proto_task=1
@@ -26,12 +28,16 @@ proto_l2tp_init_config() {
 proto_l2tp_setup() {
 	local interface="$1"
 	local optfile="/tmp/l2tp/options.${interface}"
-	local ip serv_addr server host
+	local ip serv_addr server host route_interface route_disable
+
+	json_get_vars server route_interface route_disable
 
-	json_get_var server server
 	host="${server%:*}"
-	for ip in $(resolveip -t 5 "$host"); do
-		( proto_add_host_dependency "$interface" "$ip" )
+	for ip in $(resolveip -14 -t 5 "$host"); do
+		if [ "$route_disable" != "1" ]; then
+			( proto_add_host_dependency "$interface" "$ip" $route_interface )
+		fi
+		server=$ip
 		serv_addr=1
 	done
 	[ -n "$serv_addr" ] || {
-- 
2.17.0

